diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.cpp
index 523722e4..7c4d0bb9 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.cpp
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.cpp
@@ -33,15 +33,16 @@ namespace SHADE
 
   void SHRenderable::OnDestroy()
   {
+    // Remove from SuperBatch
+    Handle<SHSuperBatch> superBatch = sharedMaterial->GetBaseMaterial()->GetPipeline()->GetPipelineState().GetSubpass()->GetSuperBatch();
+	superBatch->Remove(this);
+
+    // Free resources
     if (material)
     {
       material.Free();
       material = {};
     }
-
-    // Remove from SuperBatch
-    Handle<SHSuperBatch> superBatch = sharedMaterial->GetBaseMaterial()->GetPipeline()->GetPipelineState().GetSubpass()->GetSuperBatch();
-	superBatch->Remove(this);
   }
   
   /*-----------------------------------------------------------------------------------*/
@@ -53,20 +54,23 @@ namespace SHADE
     if (!material && sharedMaterial == materialInstance)
       return;
 
+    // Flag that material was changed
+    materialChanged = true;
+
     // Free copies of materials if any
     if (material)
     {
+      oldMaterial = material;
       material.Free();
       material = {};
     }
-
-    // Flag that material was changed
-	materialChanged = true;
-    if (sharedMaterial)
-	  oldMaterial = sharedMaterial->GetBaseMaterial();
+    else if (sharedMaterial)
+    {
+      oldMaterial = sharedMaterial;
+    }
 
     // Update the material
-    sharedMaterial = materialInstance;	
+    sharedMaterial = materialInstance;
   }
 
   Handle<SHMaterialInstance> SHRenderable::GetMaterial() const
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
index 95b53b9e..75e42d60 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHRenderable.h
@@ -55,7 +55,7 @@ namespace SHADE
       /* Getter Functions                                                              */
       /*-------------------------------------------------------------------------------*/
       bool WasMaterialChanged() const noexcept { return materialChanged; }
-      Handle<SHMaterial> GetPrevMaterial() const noexcept { return oldMaterial; }
+      Handle<SHMaterialInstance> GetPrevMaterial() const noexcept { return oldMaterial; }
       uint8_t GetLightLayer (void) const noexcept;
 
       /*-------------------------------------------------------------------------------*/
@@ -75,7 +75,7 @@ namespace SHADE
       Handle<SHMaterialInstance> sharedMaterial;
       Handle<SHMaterialInstance> material;
       bool materialChanged = true;
-      Handle<SHMaterial> oldMaterial; 
+      Handle<SHMaterialInstance> oldMaterial; 
       uint8_t lightLayer;
 	};
 }
diff --git a/SHADE_Engine/src/Math/SHMatrix.cpp b/SHADE_Engine/src/Math/SHMatrix.cpp
index 571fa4e0..ec3951e2 100644
--- a/SHADE_Engine/src/Math/SHMatrix.cpp
+++ b/SHADE_Engine/src/Math/SHMatrix.cpp
@@ -295,32 +295,33 @@ namespace SHADE
     ) != 0;
   }
 
+  SHMatrix::operator XMMATRIX() const noexcept
+  {
+    return XMLoadFloat4x4(this);
+  }
+
   SHMatrix operator*(float lhs, const SHMatrix& rhs) noexcept
   {
     return rhs * lhs;
   }
 
-
   /*-----------------------------------------------------------------------------------*/
   /* Function Member Definitions                                                       */
   /*-----------------------------------------------------------------------------------*/
 
   void SHMatrix::Transpose() noexcept
   {
-    const XMMATRIX M = XMLoadFloat4x4(this);
-    XMStoreFloat4x4(this, XMMatrixTranspose(M));
+    XMStoreFloat4x4(this, XMMatrixTranspose(*this));
   }
 
   void SHMatrix::Invert() noexcept
   {
-    const XMMATRIX M = XMLoadFloat4x4(this);
-    XMStoreFloat4x4(this, XMMatrixInverse(nullptr, M));
+    XMStoreFloat4x4(this, XMMatrixInverse(nullptr, *this));
   }
 
   float SHMatrix::Determinant() const noexcept
   {
-    const XMMATRIX M = XMLoadFloat4x4(this);
-    return XMVectorGetX(XMMatrixDeterminant(M));
+    return XMVectorGetX(XMMatrixDeterminant(*this));
   }
 
   std::string SHMatrix::ToString() const noexcept
@@ -337,9 +338,8 @@ namespace SHADE
   bool SHMatrix::Decompose(SHVec3& translation, SHVec3& rotation, SHVec3& scale) const noexcept
   {
     XMVECTOR s, r, t;
-    const XMMATRIX M = XMLoadFloat4x4(this);
 
-    if (!XMMatrixDecompose(&s, &r, &t, M))
+    if (!XMMatrixDecompose(&s, &r, &t, *this))
         return false;
 
     SHQuaternion orientation;
@@ -356,9 +356,8 @@ namespace SHADE
   bool SHMatrix::Decompose(SHVec3& translation, SHQuaternion& orientation, SHVec3& scale) const noexcept
   {
     XMVECTOR s, r, t;
-    const XMMATRIX M = XMLoadFloat4x4(this);
 
-    if (!XMMatrixDecompose(&s, &r, &t, M))
+    if (!XMMatrixDecompose(&s, &r, &t, *this))
         return false;
 
     XMStoreFloat3(&scale, s);
@@ -376,8 +375,7 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMMATRIX M = XMLoadFloat4x4(&matrix);
-    XMStoreFloat4x4(&result, XMMatrixTranspose(M));
+    XMStoreFloat4x4(&result, XMMatrixTranspose(matrix));
     return result;
   }
 
@@ -385,8 +383,7 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMMATRIX M = XMLoadFloat4x4(&matrix);
-    XMStoreFloat4x4(&result, XMMatrixInverse(nullptr, M));
+    XMStoreFloat4x4(&result, XMMatrixInverse(nullptr, matrix));
     return result;
   }
 
@@ -401,8 +398,8 @@ namespace SHADE
   SHMatrix SHMatrix::Translate(const SHVec3& pos) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixTranslation(pos.x, pos.y, pos.z));
 
+    XMStoreFloat4x4(&result, XMMatrixTranslation(pos.x, pos.y, pos.z));
     return result;
   }
 
@@ -410,25 +407,23 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMVECTOR A = XMLoadFloat3(&axis);
-    XMStoreFloat4x4(&result, XMMatrixRotationAxis(A, angleInRad));
-
+    XMStoreFloat4x4(&result, XMMatrixRotationAxis(axis, angleInRad));
     return result;
   }
 
   SHMatrix SHMatrix::Rotate(float yaw, float pitch, float roll) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixRotationRollPitchYaw(pitch, yaw, roll));
 
+    XMStoreFloat4x4(&result, XMMatrixRotationRollPitchYaw(pitch, yaw, roll));
     return result;
   }
 
   SHMatrix SHMatrix::Rotate(const SHVec3& eulerAngles) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixRotationRollPitchYaw(eulerAngles.x, eulerAngles.y, eulerAngles.z));
 
+    XMStoreFloat4x4(&result, XMMatrixRotationRollPitchYawFromVector(eulerAngles));
     return result;
   }
 
@@ -436,57 +431,55 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    XMStoreFloat4x4(&result, XMMatrixRotationQuaternion(Q));
-
+    XMStoreFloat4x4(&result, XMMatrixRotationQuaternion(q));
     return result;
   }
 
   SHMatrix SHMatrix::RotateX(float angleInRad) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixRotationX(angleInRad));
 
+    XMStoreFloat4x4(&result, XMMatrixRotationX(angleInRad));
     return result;
   }
 
   SHMatrix SHMatrix::RotateY(float angleInRad) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixRotationY(angleInRad));
 
+    XMStoreFloat4x4(&result, XMMatrixRotationY(angleInRad));
     return result;
   }
 
   SHMatrix SHMatrix::RotateZ(float angleInRad) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixRotationZ(angleInRad));
 
+    XMStoreFloat4x4(&result, XMMatrixRotationZ(angleInRad));
     return result;
   }
 
   SHMatrix SHMatrix::Scale(float uniformScaleFactor) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixScaling(uniformScaleFactor, uniformScaleFactor, uniformScaleFactor));
 
+    XMStoreFloat4x4(&result, XMMatrixScaling(uniformScaleFactor, uniformScaleFactor, uniformScaleFactor));
     return result;
   }
 
   SHMatrix SHMatrix::Scale(float x, float y, float z) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixScaling(x, y, z));
 
+    XMStoreFloat4x4(&result, XMMatrixScaling(x, y, z));
     return result;
   }
 
   SHMatrix SHMatrix::Scale(const SHVec3& scale) noexcept
   {
     SHMatrix result;
-    XMStoreFloat4x4(&result, XMMatrixScaling(scale.x, scale.y, scale.z));
 
+    XMStoreFloat4x4(&result, XMMatrixScalingFromVector(scale));
     return result;
   }
 
@@ -494,12 +487,7 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMVECTOR EYE  = XMLoadFloat3(&eye);
-    const XMVECTOR TGT  = XMLoadFloat3(&target);
-    const XMVECTOR UP   = XMLoadFloat3(&up);
-
-    XMStoreFloat4x4(&result, XMMatrixLookAtRH(EYE, TGT, UP));
-
+    XMStoreFloat4x4(&result, XMMatrixLookAtRH(eye, target, up));
     return result;
   }
 
@@ -507,12 +495,7 @@ namespace SHADE
   {
     SHMatrix result;
 
-    const XMVECTOR EYE  = XMLoadFloat3(&eye);
-    const XMVECTOR TGT  = XMLoadFloat3(&target);
-    const XMVECTOR UP   = XMLoadFloat3(&up);
-
-    XMStoreFloat4x4(&result, XMMatrixLookAtLH(EYE, TGT, UP));
-
+    XMStoreFloat4x4(&result, XMMatrixLookAtLH(eye, target, up));
     return result;
   }
 
@@ -522,8 +505,8 @@ namespace SHADE
 
     const SHVec3   FWD_HAT  = SHVec3::Normalise(-forward);
 
-    const XMVECTOR Z_HAT    = XMVector3Normalize(XMLoadFloat3(&FWD_HAT));
-    const XMVECTOR X_HAT    = XMVector3Normalize(XMVector3Cross(XMLoadFloat3(&up), Z_HAT));
+    const XMVECTOR Z_HAT    = XMVector3Normalize(FWD_HAT);
+    const XMVECTOR X_HAT    = XMVector3Normalize(XMVector3Cross(up, Z_HAT));
     const XMVECTOR Y_HAT    = XMVector3Cross(Z_HAT, X_HAT);
 
     XMStoreFloat3(reinterpret_cast<XMFLOAT3*>(&result._11), X_HAT);
@@ -543,8 +526,8 @@ namespace SHADE
 
     const SHVec3   FWD_HAT  = SHVec3::Normalise(forward);
 
-    const XMVECTOR Z_HAT    = XMVector3Normalize(XMLoadFloat3(&FWD_HAT));
-    const XMVECTOR X_HAT    = XMVector3Normalize(XMVector3Cross(XMLoadFloat3(&up), Z_HAT));
+    const XMVECTOR Z_HAT    = XMVector3Normalize(FWD_HAT);
+    const XMVECTOR X_HAT    = XMVector3Normalize(XMVector3Cross(up, Z_HAT));
     const XMVECTOR Y_HAT    = XMVector3Cross(Z_HAT, X_HAT);
 
     XMStoreFloat3(reinterpret_cast<XMFLOAT3*>(&result._11), X_HAT);
@@ -563,7 +546,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixPerspectiveFovRH(fov, aspectRatio, nearPlane, farPlane));
-
     return result;
   }
 
@@ -572,7 +554,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixPerspectiveFovLH(fov, aspectRatio, nearPlane, farPlane));
-
     return result;
   }
 
@@ -581,7 +562,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixPerspectiveRH(width, height, nearPlane, farPlane));
-
     return result;
   }
 
@@ -590,7 +570,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixPerspectiveLH(width, height, nearPlane, farPlane));
-
     return result;
   }
 
@@ -599,7 +578,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixOrthographicRH(width, height, nearPlane, farPlane));
-
     return result;
   }
 
@@ -608,7 +586,6 @@ namespace SHADE
     SHMatrix result;
 
     XMStoreFloat4x4(&result, XMMatrixOrthographicLH(width, height, nearPlane, farPlane));
-
     return result;
   }
 
diff --git a/SHADE_Engine/src/Math/SHMatrix.h b/SHADE_Engine/src/Math/SHMatrix.h
index 7a662478..4d8f1bfe 100644
--- a/SHADE_Engine/src/Math/SHMatrix.h
+++ b/SHADE_Engine/src/Math/SHMatrix.h
@@ -77,6 +77,8 @@ namespace SHADE
     SHMatrix&               operator=   (const SHMatrix& rhs) = default;
     SHMatrix&               operator=   (SHMatrix&& rhs)      = default;
 
+    operator DirectX::XMMATRIX          ()                    const noexcept;
+
     SHMatrix&               operator+=  (const SHMatrix& rhs)       noexcept;
     SHMatrix&               operator-=  (const SHMatrix& rhs)       noexcept;
     SHMatrix&               operator*=  (const SHMatrix& rhs)       noexcept;
diff --git a/SHADE_Engine/src/Math/SHQuaternion.cpp b/SHADE_Engine/src/Math/SHQuaternion.cpp
index 33c568a5..3564916a 100644
--- a/SHADE_Engine/src/Math/SHQuaternion.cpp
+++ b/SHADE_Engine/src/Math/SHQuaternion.cpp
@@ -36,44 +36,18 @@ namespace SHADE
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
   {}
 
+  SHQuaternion::SHQuaternion(const SHVec4& vec4) noexcept
+  : XMFLOAT4( vec4.x, vec4.y, vec4.z, vec4.w )
+  {}
+
   SHQuaternion::SHQuaternion(float _x, float _y, float _z, float _w) noexcept
   : XMFLOAT4( _x, _y, _z, _w )
   {}
 
-  SHQuaternion::SHQuaternion(float yaw, float pitch, float roll) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYaw(pitch, yaw, roll));
-  }
-
-  SHQuaternion::SHQuaternion(const SHVec3& eulerAngles) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMVECTOR V = XMLoadFloat3(&eulerAngles);
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(V));
-  }
-
-  SHQuaternion::SHQuaternion(const SHVec3& axis, float angleInRad) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMVECTOR AXIS = XMLoadFloat3(&axis);
-    XMStoreFloat4(this, XMQuaternionRotationAxis(AXIS, angleInRad));
-  }
-
-  SHQuaternion::SHQuaternion(const SHMatrix& rotationMatrix) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMMATRIX M = XMLoadFloat4x4(&rotationMatrix);
-    XMStoreFloat4(this, XMQuaternionRotationMatrix(M));
-  }
-
   SHQuaternion::SHQuaternion(const reactphysics3d::Vector3& rp3dEuler) noexcept
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
   {
-    const SHVec3& SHADE_VEC{ rp3dEuler };
-
-    const XMVECTOR V = XMLoadFloat3(&SHADE_VEC);
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(V));
+    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(SHVec3 { rp3dEuler }));
   }
 
   SHQuaternion::SHQuaternion(const reactphysics3d::Quaternion& rp3dQuat) noexcept
@@ -113,10 +87,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMVectorAdd(Q1, Q2));
+    XMStoreFloat4(&result, XMVectorAdd(*this, rhs));
     return result;
   }
 
@@ -124,10 +95,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMVectorSubtract(Q1, Q2));
+    XMStoreFloat4(&result, XMVectorSubtract(*this, rhs));
     return result;
   }
 
@@ -135,9 +103,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-
-    XMStoreFloat4(&result, XMVectorNegate(Q));
+    XMStoreFloat4(&result, XMVectorNegate(*this));
     return result;
   }
 
@@ -145,10 +111,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMQuaternionMultiply(Q1, Q2));
+    XMStoreFloat4(&result, XMQuaternionMultiply(*this, rhs));
     return result;
   }
 
@@ -156,9 +119,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-
-    XMStoreFloat4(&result, XMVectorScale(Q, rhs));
+    XMStoreFloat4(&result, XMVectorScale(*this, rhs));
     return result;
   }
 
@@ -166,27 +127,18 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMQuaternionInverse(XMLoadFloat4(&rhs));
-
-    XMStoreFloat4(&result, XMQuaternionMultiply(Q1, Q2));
+    XMStoreFloat4(&result, XMQuaternionMultiply(*this, XMQuaternionInverse(rhs)));
     return result;
   }
 
   bool SHQuaternion::operator==(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMQuaternionEqual(Q1, Q2);
+    return XMQuaternionEqual(*this, rhs);
   }
 
   bool SHQuaternion::operator!=(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMQuaternionNotEqual(Q1, Q2);
+    return XMQuaternionNotEqual(*this, rhs);
   }
 
   SHQuaternion::operator reactphysics3d::Quaternion() const noexcept
@@ -199,6 +151,11 @@ namespace SHADE
     return reactphysics3d::Vector3{ ToEuler() };
   }
 
+  SHQuaternion::operator XMVECTOR() const noexcept
+  {
+    return XMLoadFloat4(this);
+  }
+
   SHQuaternion operator*(float lhs, const SHQuaternion& rhs) noexcept
   {
     return rhs * lhs;
@@ -213,8 +170,7 @@ namespace SHADE
     XMVECTOR axis;
     float angle;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMQuaternionToAxisAngle(&axis, &angle, Q);
+    XMQuaternionToAxisAngle(&axis, &angle, *this);
     return angle;
   }
 
@@ -223,8 +179,7 @@ namespace SHADE
     XMVECTOR axis;
     float angle;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMQuaternionToAxisAngle(&axis, &angle, Q);
+    XMQuaternionToAxisAngle(&axis, &angle, *this);
 
 
     return SHVec4{XMVectorGetX(axis), XMVectorGetY(axis), XMVectorGetZ(axis), angle};
@@ -238,64 +193,49 @@ namespace SHADE
 
   void SHQuaternion::Invert() noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMStoreFloat4(this, XMQuaternionInverse(Q));
+    XMStoreFloat4(this, XMQuaternionInverse(*this));
   }
 
   float SHQuaternion::Length() const noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    return XMVectorGetX(XMQuaternionLength(Q));
+    return XMVectorGetX(XMQuaternionLength(*this));
   }
 
   float SHQuaternion::LengthSquared() const noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    return XMVectorGetX(XMQuaternionLengthSq(Q));
+    return XMVectorGetX(XMQuaternionLengthSq(*this));
   }
 
   float SHQuaternion::Dot(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMVectorGetX(XMQuaternionDot(Q1, Q2));
-  }
-
-  SHQuaternion SHQuaternion::RotateTowards(const SHQuaternion&, float) const noexcept
-  {
-    SHQuaternion result;
-
-    // TODO (Diren)
-
-    return result;
+    return XMVectorGetX(XMQuaternionDot(*this, rhs));
   }
 
   SHVec3 SHQuaternion::ToEuler() const noexcept
   {
-    const float xx = x * x;
-    const float yy = y * y;
-    const float zz = z * z;
+    const float XX = x * x;
+    const float YY = y * y;
+    const float ZZ = z * z;
 
-    const float m31 = 2.f * x * z + 2.f * y * w;
-    const float m32 = 2.f * y * z - 2.f * x * w;
-    const float m33 = 1.f - 2.f * xx - 2.f * yy;
+    const float M_31 = 2.f * x * z + 2.f * y * w;
+    const float M_32 = 2.f * y * z - 2.f * x * w;
+    const float M_33 = 1.f - 2.f * XX - 2.f * YY;
 
-    const float cy = sqrtf(m33 * m33 + m31 * m31);
-    const float cx = atan2f(-m32, cy);
-    if (cy > 16.0f * SHMath::EPSILON)
+    const float CY = sqrtf(M_33 * M_33 + M_31 * M_31);
+    const float CX = atan2f(-M_32, CY);
+    if (CY > 16.0f * SHMath::EPSILON)
     {
-        const float m12 = 2.f * x * y + 2.f * z * w;
-        const float m22 = 1.f - 2.f * xx - 2.f * zz;
+      const float M_12 = 2.f * x * y + 2.f * z * w;
+      const float M_22 = 1.f - 2.f * XX - 2.f * ZZ;
 
-        return SHVec3(cx, atan2f(m31, m33), atan2f(m12, m22));
+      return SHVec3(CX, atan2f(M_31, M_33), atan2f(M_12, M_22));
     }
     else
     {
-        const float m11 = 1.f - 2.f * yy - 2.f * zz;
-        const float m21 = 2.f * x * y - 2.f * z * w;
+      const float m11 = 1.f - 2.f * YY - 2.f * ZZ;
+      const float m21 = 2.f * x * y - 2.f * z * w;
 
-        return SHVec3(cx, 0.f, atan2f(-m21, m11));
+      return SHVec3(CX, 0.f, atan2f(-m21, m11));
     }
   }
 
@@ -311,13 +251,43 @@ namespace SHADE
   /* Static Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
 
+  SHQuaternion SHQuaternion::FromEuler(const SHVec3& eulerAngles) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationRollPitchYawFromVector(eulerAngles));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromPitchYawRoll(float pitch, float yaw, float roll) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationRollPitchYaw(pitch, yaw, roll));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromAxisAngle(const SHVec3& axis, float angle) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationAxis(axis, angle));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromRotationMatrix(const SHMatrix& rotationMatrix) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationMatrix(rotationMatrix));
+    return result;
+  }
+
   SHQuaternion SHQuaternion::Normalise(const SHQuaternion& q) noexcept
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    
-    XMStoreFloat4(&result, XMQuaternionNormalize(Q));
+    XMStoreFloat4(&result, XMQuaternionNormalize(q));
     return result;
   }
 
@@ -325,9 +295,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    
-    XMStoreFloat4(&result, XMQuaternionConjugate(Q));
+    XMStoreFloat4(&result, XMQuaternionConjugate(q));
     return result;
   }
 
@@ -335,26 +303,37 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    XMStoreFloat4(&result, XMQuaternionInverse(Q));
-
+    XMStoreFloat4(&result, XMQuaternionInverse(q));
     return result;
   }
 
 
-  float SHQuaternion::Angle(const SHQuaternion&, const SHQuaternion&) noexcept
+  float SHQuaternion::Angle(const SHQuaternion& q1, const SHQuaternion& q2) noexcept
   {
-    // TODO (Diren)
+    XMVECTOR R = XMQuaternionMultiply(XMQuaternionConjugate(q1), q2);
 
-    return 0.0f;
+    const float RS = XMVectorGetW(R);
+    R = XMVector3Length(R);
+    return 2.0f * atan2f(XMVectorGetX(R), RS);
   }
 
-  SHQuaternion SHQuaternion::Lerp(const SHQuaternion&, const SHQuaternion&, float) noexcept
+  SHQuaternion SHQuaternion::Lerp(const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept
   {
     SHQuaternion result;
 
-    // TODO (Diren)
+    XMVECTOR R = XMVectorZero();
+    if (XMVector4GreaterOrEqual(XMVector4Dot(q1, q2), R))
+    {
+      R = XMVectorLerp(q1, q2, t);
+    }
+    else
+    {
+      const XMVECTOR X0 = XMVectorMultiply(q1, XMVectorReplicate(1.f - t));
+      const XMVECTOR X1 = XMVectorMultiply(q2, XMVectorReplicate(t));
+      R = XMVectorSubtract(X0, X1);
+    }
 
+    XMStoreFloat4(&result, XMQuaternionNormalize(R));
     return result;
   }
 
@@ -362,19 +341,105 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(&q1);
-    const XMVECTOR Q2 = XMLoadFloat4(&q2);
-
-    XMStoreFloat4(&result, XMQuaternionSlerp(Q1, Q2, t));
+    XMStoreFloat4(&result, XMQuaternionSlerp(q1, q2, t));
     return result;
   }
 
-  SHQuaternion SHQuaternion::Rotate(const SHVec3& , const SHVec3&) noexcept
+  SHQuaternion SHQuaternion::ClampedLerp(const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin, float tMax) noexcept
+  {
+    return Lerp(q1, q2, std::clamp(t, tMin, tMax));
+  }
+
+
+  SHQuaternion SHQuaternion::ClampedSlerp(const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin, float tMax) noexcept
+  {
+    return Slerp(q1, q2, std::clamp(t, tMin, tMax));
+  }
+
+  SHQuaternion SHQuaternion::FromToRotation(const SHVec3& from, const SHVec3& to) noexcept
+  {
+    // Melax, "The Shortest Arc Quaternion", Game Programming Gems
+
+    SHQuaternion result;
+
+    const XMVECTOR F = XMVector3Normalize(from);
+    const XMVECTOR T = XMVector3Normalize(to);
+
+    const float dot = XMVectorGetX(XMVector3Dot(F, T));
+    if (dot >= 1.f)
+    {
+        result = Identity;
+    }
+    else if (dot <= -1.f)
+    {
+        XMVECTOR axis = XMVector3Cross(F, SHVec3::Right);
+        if (XMVector3NearEqual(XMVector3LengthSq(axis), g_XMZero, g_XMEpsilon))
+        {
+            axis = XMVector3Cross(F, SHVec3::Up);
+        }
+
+        const XMVECTOR Q = XMQuaternionRotationAxis(axis, XM_PI);
+        XMStoreFloat4(&result, Q);
+    }
+    else
+    {
+        const XMVECTOR C = XMVector3Cross(F, T);
+        XMStoreFloat4(&result, C);
+
+        const float s = sqrtf((1.f + dot) * 2.f);
+        result.x /= s;
+        result.y /= s;
+        result.z /= s;
+        result.w = s * 0.5f;
+    }
+
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::LookRotation(const SHVec3& forward, const SHVec3& up) noexcept
   {
     SHQuaternion result;
 
-    // TODO (Diren)
+    const SHQuaternion Q1 = FromToRotation(SHVec3::Forward, forward);
 
+    const XMVECTOR C = XMVector3Cross(forward, up);
+    if (XMVector3NearEqual(XMVector3LengthSq(C), g_XMZero, g_XMEpsilon))
+    {
+        // forward and up are co-linear
+        return Q1;
+    }
+
+    SHVec3 qU;
+    XMStoreFloat3(&qU, XMQuaternionMultiply(Q1, SHVec3::Up));
+
+    const SHQuaternion Q2 = FromToRotation(qU, up);
+
+    XMStoreFloat4(&result, XMQuaternionMultiply(Q2, Q1));
+
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::RotateTowards(const SHQuaternion& from, const SHQuaternion& to, float maxAngleInRad) noexcept
+  {
+    SHQuaternion result;
+
+    // We can use the conjugate here instead of inverse assuming q1 & q2 are normalized.
+    const XMVECTOR R = XMQuaternionMultiply(XMQuaternionConjugate(from), to);
+
+    const float RS = XMVectorGetW(R);
+    const XMVECTOR L = XMVector3Length(R);
+    const float angle = 2.f * atan2f(XMVectorGetX(L), RS);
+    if (angle > maxAngleInRad)
+    {
+        const XMVECTOR delta = XMQuaternionRotationAxis(R, maxAngleInRad);
+        const XMVECTOR Q = XMQuaternionMultiply(delta, from);
+        XMStoreFloat4(&result, Q);
+    }
+    else
+    {
+        // Don't overshoot.
+        result = to;
+    }
     return result;
   }
 
diff --git a/SHADE_Engine/src/Math/SHQuaternion.h b/SHADE_Engine/src/Math/SHQuaternion.h
index c94907b5..fa5b5d36 100644
--- a/SHADE_Engine/src/Math/SHQuaternion.h
+++ b/SHADE_Engine/src/Math/SHQuaternion.h
@@ -49,11 +49,8 @@ namespace SHADE
     SHQuaternion  (SHQuaternion&& rhs)      = default;
 
     SHQuaternion  ()                                            noexcept;
+    SHQuaternion  (const SHVec4& vec4)                          noexcept;
     SHQuaternion  (float x, float y, float z, float w)          noexcept;
-    SHQuaternion  (float yaw, float pitch, float roll)          noexcept;
-    SHQuaternion  (const SHVec3& eulerAngles)                   noexcept;
-    SHQuaternion  (const SHVec3& axis, float angleInRad)        noexcept;
-    SHQuaternion  (const SHMatrix& rotationMatrix)              noexcept;
 
     // Conversion from other math types
 
@@ -87,6 +84,7 @@ namespace SHADE
 
     operator reactphysics3d::Quaternion       ()                        const noexcept;
     operator reactphysics3d::Vector3          ()                        const noexcept;
+    operator DirectX::XMVECTOR                ()                        const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Getter Functions                                                                */
@@ -99,29 +97,37 @@ namespace SHADE
     /* Function Members                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    void                        Invert        ()                                                      noexcept;
+    void                        Invert        ()  noexcept;
 
-    [[nodiscard]] float         Length        ()                                                const noexcept;
-    [[nodiscard]] float         LengthSquared ()                                                const noexcept;
-    [[nodiscard]] float         Dot           (const SHQuaternion& rhs)                         const noexcept;
-    [[nodiscard]] SHQuaternion  RotateTowards (const SHQuaternion& target, float maxAngleInRad) const noexcept;
+    [[nodiscard]] float         Length        ()  const noexcept;
+    [[nodiscard]] float         LengthSquared ()  const noexcept;
+    [[nodiscard]] float         Dot           (const SHQuaternion& rhs) const noexcept;
 
-    [[nodiscard]] SHVec3        ToEuler       ()                                                const noexcept;
-    [[nodiscard]] std::string   ToString      ()                                                const noexcept;
+    [[nodiscard]] SHVec3        ToEuler       ()  const noexcept;
+    [[nodiscard]] std::string   ToString      ()  const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Static Function Members                                                         */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] static SHQuaternion Normalise (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static SHQuaternion Conjugate (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static SHQuaternion Inverse   (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static float        Angle     (const SHQuaternion& q1, const SHQuaternion& q2)          noexcept;
+    [[nodiscard]] static SHQuaternion FromEuler         (const SHVec3& eulerAngles)           noexcept;
+    [[nodiscard]] static SHQuaternion FromPitchYawRoll  (float pitch, float yaw, float roll)  noexcept;
+    [[nodiscard]] static SHQuaternion FromAxisAngle     (const SHVec3& axis, float angle)     noexcept;
+    [[nodiscard]] static SHQuaternion FromRotationMatrix(const SHMatrix& rotationMatrix)      noexcept;
 
-    [[nodiscard]] static SHQuaternion Lerp      (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
-    [[nodiscard]] static SHQuaternion Slerp     (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion Normalise         (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static SHQuaternion Conjugate         (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static SHQuaternion Inverse           (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static float        Angle             (const SHQuaternion& q1, const SHQuaternion& q2) noexcept;
 
-    [[nodiscard]] static SHQuaternion Rotate    (const SHVec3& from, const SHVec3& to)                    noexcept;
+    [[nodiscard]] static SHQuaternion Lerp              (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion Slerp             (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion ClampedLerp       (const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
+    [[nodiscard]] static SHQuaternion ClampedSlerp      (const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
+
+    [[nodiscard]] static SHQuaternion FromToRotation  (const SHVec3& from, const SHVec3& to)    noexcept;
+    [[nodiscard]] static SHQuaternion LookRotation    (const SHVec3& forward, const SHVec3& up) noexcept;
+    [[nodiscard]] static SHQuaternion RotateTowards   (const SHQuaternion& from, const SHQuaternion& to, float maxAngleInRad) noexcept;
   };
 
   SHQuaternion operator*(float lhs, const SHQuaternion& rhs) noexcept;
